#pragma once

#include <math.h>
#include "UIListCommonDefine.hpp"
#include "CommonType.h"


namespace DuiLib
{

struct NodeData
{
	int level_;
	bool folder_;
	bool selected_;
	bool child_visible_;
	bool has_child_;
	CDuiString text_;
	CDuiString value;
	int status; // compare data;
	CString tel;
	CListContainerElementUI* list_elment_;
    NodeData()
    {
        level_ = 0;
        folder_ = false;
		selected_ = false;
        child_visible_ = false;
        has_child_ = false;
        status = 0;
        list_elment_ = NULL;
		tel = _T("");
		text_  = _T("");
		value  = _T("");
    }
};

double CalculateDelay(double state);
typedef int (CALLBACK *PNodeCompareFunc)(void*, void*);

class Node
{
public:
	Node();
	explicit Node(NodeData t);
	Node(NodeData t, Node* parent);
	~Node();
	NodeData& data();
	NE_MEMBER_DATA& member_data();
	void SetMemberData(const NE_MEMBER_DATA* pdata);

	DWORD GetNodeUserData(){
        ASSERT(m_userData != 0);
		return m_userData;
	}
	void SetNodeUserData(DWORD userData){
		ASSERT(userData != 0);
		ASSERT(m_userData == 0); //set once
		m_userData = userData;
	}
	int num_children() const;
	Node* child(int i);
	Node* parent();
	bool folder() const;
	bool IsRoot() const;
	bool has_children() const;
	void add_child(Node* child);
	void insert_child(Node* child, int nIndex);
	void reinsert_child(Node* child, int nIndex);////reinsert_child()뿴cppļĺ˵

	void remove_child(Node* child);
	Node* get_last_child();
	void SortChidren(PNodeCompareFunc pCompareFunc);

	void SetComapreData(int nData);
	int GetCompareData();

protected:
	static int __cdecl ItemComareFunc(void *pvlocale, const void *item1, const void *item2);
	int __cdecl ItemComareFunc(const void *node1, const void *node2);
	PNodeCompareFunc m_pCompareFunc;
	int m_compareData;
	DWORD m_userData;


private:
	void set_parent(Node* parent);

private:
	typedef std::vector <Node*>	Children;

	Children	children_;
	Node*		parent_;

	NodeData    data_;
	NE_MEMBER_DATA  member_data_;
};

} // DuiLib
